> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/products/web-scraper-api/targets/search-engines/google/trends-explore.md).

# Trends: Explore

Extract Google Trends data by keyword, date range, and category. API supports multiple search types and filtering.

The `google_trends_explore` source is designed to retrieve Google Trends results.

{% hint style="warning" %}
Due to ongoing issues, the scraped data may not be 100% accurate compared to direct usage on Google Trends via web browsers. Please use it with caution and be aware of potential discrepancies.
{% endhint %}

## Request samples

In this example, we make a request to get trends results for a search term `adidas` between the 1st of January, 2021 and the 2nd of February, 2022, and set the category to "Arts & Entertainment" (category id: `3`).

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://data.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "google_trends_explore",
        "query": "adidas",
        "context": [
            {"key": "date_from", "value": "2021-01-01"},
            {"key": "date_to", "value": "2022-02-02"},
            {"key": "category_id", "value": 3}
        ]
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint


# Structure payload.
payload = {
    'source': 'google_trends_explore',
    'query': 'adidas',
    'context': [
        {'key': 'date_from', 'value': '2021-01-01'},
        {'key': 'date_to', 'value': '2022-02-02'},
        {'key': 'category_id', 'value': 3},
    ],
}


# Get response.
response = requests.request(
    'POST',
    'https://data.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload,
)

# Print prettified response to stdout.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "google_trends_explore",
    query: "adidas",
    context: [
        { key: "date_from", value: "2021-01-01" },
        { key: "date_to", value: "2022-02-02" },
        { key: "category_id", value: 3 },
    ],
};

const options = {
    hostname: "data.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'google_trends_explore',
    'query' => 'adidas',
    'context' => [
        ['key' => 'date_from', 'value' => '2021-01-01'],
        ['key' => 'date_to', 'value' => '2022-02-02'],
        ['key' => 'category_id', 'value' => 3]
    ]
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://data.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");


$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
    "bytes"
    "encoding/json"
    "fmt"
    "io/ioutil"
    "net/http"
)

func main() {
    const Username = "USERNAME"
    const Password = "PASSWORD"

    payload := map[string]interface{}{
        "source": "google_trends_explore",
        "query":  "adidas",
        "context": []map[string]interface{}{
            {"key": "date_from", "value": "2021-01-01"},
            {"key": "date_to", "value": "2022-02-02"},
            {"key": "category_id", "value": 3},
        },
    }

    jsonValue, _ := json.Marshal(payload)

    client := &http.Client{}
    request, _ := http.NewRequest("POST",
        "https://data.oxylabs.io/v1/queries",
        bytes.NewBuffer(jsonValue),
    )

    request.SetBasicAuth(Username, Password)
    response, _ := client.Do(request)

    responseText, _ := ioutil.ReadAll(response.Body)
    fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "google_trends_explore",
                query = "adidas",
                context = new dynamic [] {
                    new { key = "date_from", value = "2021-01-01" },
                    new { key = "date_to", value = "2022-02-02" },
                    new { key = "category_id", value = 3 }
                }
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://data.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONArray;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "google_trends_explore");
        jsonObject.put("query", "adidas");
        jsonObject.put("context", new JSONArray()
                .put(new JSONObject().put("key", "date_from").put("value", "2021-01-01"))
                .put(new JSONObject().put("key", "date_to").put("value", "2022-02-02"))
                .put(new JSONObject().put("key", "category_id").put("value", 3))
        );

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://data.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "google_trends_explore",
    "query": "adidas",
    "context": [
        {"key": "date_from", "value": "2021-01-01"},
        {"key": "date_to", "value": "2022-02-02"},
        {"key": "category_id", "value": 3}
    ]
}
```

{% endtab %}
{% endtabs %}

We use the [**Push-Pull**](/products/web-scraper-api/integration-methods/push-pull.md) integration method in our examples. Submitting a job returns the job ID immediately, not the result. Once the job status is `done`, retrieve the results with `GET https://data.oxylabs.io/v1/queries/{job_id}/results`. See [**Push-Pull**](/products/web-scraper-api/integration-methods/push-pull.md) for checking the job status, callbacks and batch queries.

## Request parameter values

### Generic

Basic setup and customization options for scraping Google Trends results.

<table><thead><tr><th width="222">Parameter</th><th width="350.3333333333333">Description</th><th>Default Value</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong>source</strong></mark></td><td>Sets the scraper.</td><td><code>google_trends_explore</code></td></tr><tr><td><mark style="background-color:green;"><strong>query</strong></mark></td><td>The keyword or phrase to search for.</td><td>-</td></tr><tr><td><code>callback_url</code></td><td>URL to your callback endpoint. <a href="/products/web-scraper-api/integration-methods/push-pull.md"><strong>More info</strong></a></td><td>-</td></tr><tr><td><code>user_agent_type</code></td><td>Device type and browser. The full list can be found <a href="/products/web-scraper-api/features/http-context-and-job-management/user-agent-type.md"><strong>here</strong></a>.</td><td><code>desktop</code></td></tr><tr><td><code>geo_location</code></td><td>The geographical location that the result should be adapted for. With Google Trends: Explore, we accept 2-letter ISO country codes as <code>geo_location</code> parameter values.</td><td>-</td></tr></tbody></table>

\- mandatory parameter

### Filtering

Advanced options for tailoring and refining the search context.

<table><thead><tr><th width="222">Parameter</th><th width="350.3333333333333">Description</th><th>Default Value</th></tr></thead><tbody><tr><td><p><code>context</code>:</p><p><code>search_type</code></p></td><td>Lets you set the search type (one of the options on Google Trends GUI). Possible values: <code>web_search</code>, <code>image_search</code>, <code>google_shopping</code>, <code>youtube_search</code>.</td><td><code>web_search</code></td></tr><tr><td><p><code>context</code>:</p><p><code>date_from</code></p></td><td>The lower date bracket. Format: <code>YYYY-MM-DD</code>. Oldest possible date: <code>2004-01-01</code>.</td><td>-</td></tr><tr><td><p><code>context</code>:</p><p><code>date_to</code></p></td><td>The upper date bracket. Format: <code>YYYY-MM-DD</code>. Oldest possible date: <code>2004-01-01</code>.</td><td>-</td></tr><tr><td><p><code>context</code>:</p><p><code>category_id</code></p></td><td>Category ID. Please refer to <a href="https://files.gitbook.com/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FiwDdoZGfMbUe5cRL2417%2Fuploads%2Fp5oVF3fBlQV8OzBmJ3BO%2FTrends-Google-categories.json?alt=media&#x26;token=141cdee3-cb9f-43c8-99cc-befa8b6ca8ec"><strong>this file</strong></a> in story for a list of valid values.</td><td>-</td></tr></tbody></table>

### Context parameters

All context parameters should be added to the `context` array as objects with `key` and `value` pairs, e.g.:

```json
...
"context": [
    {
        "key": "filter",
        "value": "0"
    }
]
...
```

{% hint style="info" %}
**NOTE**: This service always delivers structured data - so there is no need to utilize the `parse` parameter with this source.
{% endhint %}

## Output example

```json
{
    "results": [
        {
            "content":"{\"interest_over_time\": [{\"keyword\": \"adidas\", \"items\": [{\"time\": \"Jan 3\ \–\ 9, 2021\", \"value\": 75}, {\"time\": \"Jan 10\ \–\ 16, 2021\", \"value\": 79}...{\"query\": \"adidas zx\", \"value\": 10, \"formatted_value\": \"10\", \"link\": \"/trends/explore?q=adidas+zx&date=2021-01-01+2022-02-02\"}]}]}",
            "created_at": "2024-02-13 11:33:21",
            "updated_at": "2024-02-13 11:33:27",
            "page": 1,
            "url": "https://trends.google.com/trends/api/explore?hl=en-US&tz=0&req=%7B%22comparisonItem%22%3A+%5B%7B%22keyword%22%3A+%22adidas%22%2C+%22geo%22%3A+%22%22%2C+%22time%22%3A+%222021-01-01+2022-02-02%22%7D%5D%2C+%22category%22%3A+0%2C+%22property%22%3A+%22%22%7D",
            "job_id": "7163133042662350849",
            "status_code": 200
        }
    ]
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers.oxylabs.io/products/web-scraper-api/targets/search-engines/google/trends-explore.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
